/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef COMMONDS_H
#define COMMONDS_H

/**
@author Sayantam Dey
*/
#include <qstringlist.h>
#include <qvaluevector.h>
#include <qvaluelist.h>
#include <qlistview.h>

class JobOptions
{
	public:
		bool set_flag;
		int crawl_mode;
		int crawl_depth;
		bool traverseOut;
		bool linkOutsidePath;
		QStringList fileTypeList;
		bool exclusive_flag;
		QStringList dcTypes;
		
		JobOptions();
		~JobOptions();
		QString allAttributes();
};

typedef struct 
{
	QString m_url_str;
	JobOptions job_options;
} t_KrawlJob;

typedef QValueVector<t_KrawlJob> t_KrawlJobList;

typedef struct 
{
	uint m_index;
	QListViewItem* m_item_ptr;
} 
t_UrlChildItem;

typedef struct 
{
	uint m_index;
	QValueVector<t_UrlChildItem> m_vec_ImgUrl;
	QValueVector<t_UrlChildItem> m_vec_HrefUrl;
	QListViewItem* m_item_ptr;
} 
t_UrlRootItem;

typedef QValueVector<t_UrlRootItem> t_UrlRootItemList;

typedef struct
{
	uint m_index;
	QString m_str_url;
	int m_url_type;
} t_LeechUrl;

typedef struct
{
	uint m_index;
	QValueList<t_LeechUrl> m_LeechUrlList;
} t_LeechJob;

typedef QValueList<t_LeechJob> t_LeechJobList;

namespace KrawlSiteTray
{
	enum { KST_START = 8, KST_NEXT_URL, KST_NEXT_LINK, KST_PAUSE, KST_CLEAR = 13, KST_STOP = 19, KST_ADD = 24};
}
#endif
