/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DROPWINDOW_H
#define DROPWINDOW_H

#include <kurl.h>
#include <kpopupmenu.h>

#include <qwidget.h>
#include <qbitmap.h>
#include <qevent.h>
#include <qdragobject.h>

/**
@author Sayantam Dey
*/
class DropWindow : public QWidget
{
Q_OBJECT
public:
    DropWindow(WId _container_id, int x, int y, QWidget *parent = 0, const char *name = 0);

    ~DropWindow();
	
protected:
	virtual void mousePressEvent(QMouseEvent* e);
	virtual void mouseMoveEvent(QMouseEvent* e);
	virtual void dragEnterEvent(QDragEnterEvent* e);
	virtual void dropEvent(QDropEvent* e);
	
private:
	enum popup_menu_ids
	{
		ID_CLOSE = 1, ID_SHOW_URL, ID_PARENT_SHOW, ID_ALL_DESKTOPS
	};
	QBitmap mask;
	int oldX, oldY;
	KPopupMenu* m_popup_menu;
	QStringList m_urlStrList;
	WId m_container_id;
		
	void debugMsg(QString _msg = "");
	void createPopupMenu();
	void popupMenuHandler(int _id);
				
signals:
	void droppedItem(QString);
	void droppedItem(KURL::List);
	void windowClosed(const int, const int);
};

#endif
