/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FILEMANAGER_H
#define FILEMANAGER_H

#include <kurl.h>
#include <ktoolbar.h>
#include <kdialogbase.h>
#include <kurlrequester.h>
#include <kdiroperator.h>

#include "krawlconfig.h"
#include "krawler.h"

/**
@author Sayantam Dey
*/
class FileManager : public QWidget
{
Q_OBJECT
public:
    FileManager(QWidget *parent = 0, const char *name = 0);

    ~FileManager();
	
	QString baseDlDirectory();
	KURL branchUrl();
	void resetFileView(KURL _base_path = 0);
	void initFileView();
			
public slots:
  /*$PUBLIC_SLOTS$*/
	void loadSavedDefaults();
  	void saveSettings();	
	void changeFileView(const QString&);

protected slots:
	void itemExecuted(const KFileItem* _file_item);
	void baseDirChanged();
		
protected:
	KDirOperator* m_fileView;
	KToolBar *m_ToolBar;
	bool rememberLastBaseDir;
	bool first_time;
	bool fm_show_hidden;
    KURLRequester* m_KUrlReq;
	
	/*$PROTECTED_FUNCTIONS$*/
	void createToolBar();
	void debugMsg(QString _str);
		
	enum menu_ids
	{
		ID_EXEC = 1, ID_BROWSE, ID_OPENWITH, ID_COPY_URL, ID_COPY_FILE_PATH, ID_PROPS_DLG, ID_DELETE, ID_TRASH, ID_VIEW_SRC, ID_NEWDIR, ID_SYNC_DIR
	};	  
	
	enum toolbar_ids
	{
		TBID_UP_URL = 1, TBID_HOME, TBID_NEWDIR, TBID_SEP, TBID_RELOAD, TBID_BACK, TBID_FWD
	};
};

#endif
