/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HISTORYBROWSER_H
#define HISTORYBROWSER_H

#include <klistbox.h>

#include <qwidget.h>

/**
@author Sayantam Dey
*/
class HistoryBrowser : public QWidget
{
Q_OBJECT
public:
	HistoryBrowser(QWidget *parent = 0, const char *name = 0, const QStringList& _url_list = QStringList());

    ~HistoryBrowser();

	QStringList getSelectedUrls();
	
protected slots:
	void slotItemExecuted(QListBoxItem* );
	uint averageStringLen(const QStringList& _list);

protected:
	KListBox* m_history_list;	
	
signals:
	void addUrlString(QString);
};

#endif
