/***************************************************************************
*   Copyright (C) 2004 by Sayantam Dey                                    *
*   sayantam@gmail.com                                                    *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/

#ifndef INFOPANEL_H
#define INFOPANEL_H

#include "info_panel.h"

class InfoPanel : public UICInfoPanel
{
	Q_OBJECT

public:
	InfoPanel( QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
	~InfoPanel();
	/*$PUBLIC_FUNCTIONS$*/
	void init_widget();
	void setLinkStats(int index, int _total_steps);
	void setImgStats(int index, int _total_steps);
	void setCurrentDlUrl(QString _qstr_url);
	void clearDlLabel();
	void changeKrawlDisp(const QString& _mode_str);
	void setLinkPrgsTotal(int _size);
	void setImagePrgsTotal(int _size);
	
public slots:
	/*$PUBLIC_SLOTS$*/
	void setTotalDlSize(unsigned long value);
	void setDlSpeed(unsigned long value);
	void setStatusMsg(QString qstr_status_msg);
	void progressUpdate(int percent);

protected:
	/*$PROTECTED_FUNCTIONS$*/

protected slots:
	/*$PROTECTED_SLOTS$*/

};

#endif

