/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <klocale.h>
#include <kdebug.h> 
#include <ktoolbarbutton.h>
#include <kprogress.h>
#include <kmessagebox.h>
#include <kapplication.h>
#include <kinputdialog.h> 

#include <qregexp.h>
#include <qlayout.h> 
 
#include "multijobhandler.h"
#include "krawlconfig.h"

#include "multijobhandler.moc"

MultiJobHandler::MultiJobHandler(QWidget *parent, const char *name, WId _container_id)
	: QWidget(parent, name), drop_win_x(-1), drop_win_y(-1), m_drop_target_flag(false)
{
	m_container_id = _container_id;
	QHBoxLayout* hbox_layout = new QHBoxLayout(this, 1, 1, "hbox_layout");
	
/*	m_btnDropTarget = new KPushButton(this, "drop_button");
	m_btnDropTarget->setText(i18n("&Drop Target"));
	m_btnDropTarget->setToggleButton( TRUE );
	connect(m_btnDropTarget, SIGNAL(clicked()), this, SLOT(btnDropTargetClicked()));
	hbox_layout->addWidget(m_btnDropTarget);*/
	
/*	m_cmbUrlsList = new KComboBox(true, this, "combo_url");
	connect(m_cmbUrlsList, SIGNAL(returnPressed(const QString& )), this, SLOT(cmbReturnPressed(const QString& )));
	m_cmbUrlsList->setURLDropsEnabled(true);
    m_cmbUrlsList->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)0, 0, 0, m_cmbUrlsList->sizePolicy().hasHeightForWidth() ) );
    m_cmbUrlsList->setEditable( TRUE );
    m_cmbUrlsList->setDuplicatesEnabled( FALSE );
	hbox_layout->addWidget(m_cmbUrlsList);	*/
		
	m_LeechBar = new KToolBar(this, "leech_bar", true, true);
	m_LeechBar->setIconSize(22);
// 	m_LeechBar->setFullSize( true );
	createLeechBar();
	m_LeechBar->setSizePolicy( QSizePolicy( QSizePolicy::MinimumExpanding, (QSizePolicy::SizeType)0, 0, 0, m_LeechBar->sizePolicy().hasHeightForWidth() ) );
	m_cmbUrlsList->setURLDropsEnabled(true);
    m_cmbUrlsList->setDuplicatesEnabled( false );
	connect( m_cmbUrlsList, SIGNAL( textChanged(const QString& ) ), this, SLOT(cmbTextChanged(const QString& )));
	hbox_layout->addWidget(m_LeechBar);
	this->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed, this->sizePolicy().hasHeightForWidth());
	m_dlgJobSettings = 0;
	m_history_dlg = 0;
	m_hist_br = 0;
// 	m_KrawlJobList = t_KrawlJobList(20);
// 	m_KrawlJobList.reserve(20);
}


MultiJobHandler::~MultiJobHandler()
{
}

void MultiJobHandler::init_widget(int )
{
/*	if (_mode == Krawler::Leech)
	{
		m_LeechBar->getButton(L_SAVE)->setEnabled(true);
	}
	else m_LeechBar->getButton(L_SAVE)->setEnabled(false);*/
/*	if (_mode != Krawler::Leech)
		m_LeechBar->getButton(L_SAVE)->setEnabled(false);*/
}

void MultiJobHandler::createLeechBar()
{
	int index = 0;
	m_LeechBar->insertButton("tar", L_TAR, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), true, i18n("Create Web Archive"), index++);
	m_LeechBar->insertButton("log", L_LOG, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), true, i18n("Show Log Window"), index++);
	m_LeechBar->insertButton("configure", L_CONF, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), true, i18n("Configure"), index++);
	m_LeechBar->insertLineSeparator(index++, L_SEP);
	m_LeechBar->insertButton("folder_html", L_DROP, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), true, i18n("Drop Target"), index++);
	m_btnDropTarget = m_LeechBar->getButton(L_DROP);
	m_btnDropTarget->setToggleButton( true );
	m_LeechBar->insertButton("history", L_HIST, SIGNAL(clicked(int)), this, 	SLOT(leechBarClicked(int )), true, i18n("History"), index++);
	m_LeechBar->insertCombo(QString::null, L_COMBO, true, SIGNAL(returnPressed(const QString& )), this, SLOT(cmbReturnPressed(const QString& )), true, i18n("URL list"), 0, index++);
	m_cmbUrlsList = m_LeechBar->getCombo(L_COMBO);
	m_cmbUrlsList->clear();
	m_LeechBar->setItemAutoSized(L_COMBO, true);
	m_LeechBar->insertButton("edit_add", L_ADD, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), true, i18n("Add URL"), index++);
	m_LeechBar->insertButton("editdelete", L_REMOVE, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), false, i18n("Remove URL"), index++);
	m_LeechBar->insertButton("editclear", L_CLEAR, SIGNAL(clicked(int)), this, 	SLOT(leechBarClicked(int )), false, i18n("Clear URLs"), index++);
	m_LeechBar->insertButton("enhanced_browsing", L_OPTIONS, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int )), false, i18n("Configure Job"), index++);
// 	m_LeechBar->getButton(L_OPTIONS)->setToggleButton(true);
	m_LeechBar->insertLineSeparator(index++, L_SEP);
	m_LeechBar->insertButton("player_play", L_START, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Start"), index++);	
	m_LeechBar->insertButton("player_pause", L_PAUSE, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Pause/Resume"), index++);
	m_LeechBar->getButton(L_PAUSE)->setToggleButton(true);
	m_LeechBar->insertButton("player_fwd", L_NEXT_LINK, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Next Link"), index++);	
	m_LeechBar->insertButton("player_end", L_NEXT_URL, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Next URL"), index++);	
	m_LeechBar->insertButton("player_stop", L_STOP, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Stop"), index++);	
	m_LeechBar->insertLineSeparator(index++, L_SEP);
	m_LeechBar->insertButton("filesave", L_SAVE, SIGNAL(clicked(int)), this, SLOT(leechBarClicked(int)), false, i18n("Download Selected"), index++);	
	
}

void MultiJobHandler::leechBarClicked(int id)
{
	switch(id)
	{
		case L_DROP:
		{
			btnDropTargetClicked();
			break;
		}
		case L_START:
		{
			if ( !m_cmbUrlsList->currentText().isEmpty() && m_KrawlJobList.size() == 0 )
			{
				if (!m_cmbUrlsList->contains(m_cmbUrlsList->currentText()))
				{
					m_cmbUrlsList->insertItem(m_cmbUrlsList->currentText());
				}
				createKrawlJob( m_cmbUrlsList->currentText() );
			}
			m_info_panel_inst->progressUpdate(0);
			m_info_panel_inst->setLinkPrgsTotal(0);
			m_info_panel_inst->setImagePrgsTotal(0);
			m_op_mode = MULTI_JOB;
			emit startMultiJob();
			debugMsg("not crashed here");
			break;
		}
		case L_REMOVE:
		{
			QString str_url = m_cmbUrlsList->currentText();
			int index = m_cmbUrlsList->currentItem();
			t_KrawlJobList::iterator ite ;
			int vec_index = -1;
			for ( ite = m_KrawlJobList.begin(), vec_index = 0; ite != m_KrawlJobList.end(); ite++, vec_index++)
				if ( vec_index == index )
				{
					m_KrawlJobList.erase( ite );
					break;
				}
			m_cmbUrlsList->removeItem(m_cmbUrlsList->currentItem());
			m_cmbUrlsList->setCurrentItem(m_cmbUrlsList->count() - 1);
			if (m_cmbUrlsList->count() == 0)
			{
				m_LeechBar->getButton(L_REMOVE)->setEnabled(false);
				m_LeechBar->getButton(L_CLEAR)->setEnabled(false);
				m_LeechBar->getButton(L_START)->setEnabled(false);
				m_LeechBar->getButton(L_OPTIONS)->setEnabled(false);
			}
			break;
		}
		case L_CLEAR:
		{
			m_cmbUrlsList->clear();
			m_KrawlJobList.clear();
			m_LeechBar->getButton(L_REMOVE)->setEnabled(false);
			m_LeechBar->getButton(L_CLEAR)->setEnabled(false);
			m_LeechBar->getButton(L_START)->setEnabled(false);
			m_LeechBar->getButton(L_OPTIONS)->setEnabled(false);
			break;
		}
		case L_SAVE:
		{
			m_info_panel_inst->progressUpdate(0);
			m_info_panel_inst->setLinkPrgsTotal(0);
			m_info_panel_inst->setImagePrgsTotal(0);
			m_LeechBar->getButton( L_PAUSE )->setEnabled( true );
			m_LeechBar->getButton( L_NEXT_LINK )->setEnabled( true );
			emit startLeech();
			break;
		}
		case L_NEXT_LINK:
		{
			emit jumpToNextLink();
			break;
		}
		case L_NEXT_URL:
		{
			emit jumpToNextUrl();
			break;
		}
		case L_PAUSE:
		{
			if (krawl_paused)
			{
				emit pauseKrawl(false);
				m_LeechBar->getButton(L_PAUSE)->setDown(false);
			}
			else
			{
				emit pauseKrawl(true);
				m_LeechBar->getButton(L_PAUSE)->setDown(true);
			}
			krawl_paused = !krawl_paused;
			m_info_panel_inst->setStatusMsg(i18n("Paused"));
			break;
		}
		case L_OPTIONS:
		{
			QString str_url = m_cmbUrlsList->currentText();
			int index = m_cmbUrlsList->currentItem();
			t_KrawlJob krawl_job = m_KrawlJobList[index];
			JobOptions url_settings = krawl_job.job_options;
			QuickSetOptions* qso_item_ptr = new QuickSetOptions();
			debugMsg("1:" + url_settings.allAttributes());
			qso_item_ptr->loadSettingsFromOptions(url_settings); // load the widget with the settings obejct
			if (m_dlgJobSettings)
				delete m_dlgJobSettings;
			m_dlgJobSettings = new KDialogBase(KDialogBase::Swallow, 0, this, "job settings", false, i18n("Settings for ") + str_url, KDialogBase::Ok | KDialogBase::Cancel, KDialogBase::Ok, true);
			m_dlgJobSettings->setMainWidget(qso_item_ptr);
			connect(m_dlgJobSettings, SIGNAL(okClicked()), this, SLOT(urlSettingsOkClicked()));
			m_qso_holder = qso_item_ptr;
			m_dlgJobSettings->show();
			break;
		}
		case L_STOP:
		{
			emit stopCrawling();
			break;
		}
		case L_TAR:
		{
			emit createArchive();
			break;
		}
		case L_LOG:
		{
			emit showLog();
			break;
		}
		case L_CONF:
		{
			emit showConfigure();
			break;
		}
		case L_HIST:
		{
			m_history_dlg = new KDialogBase(KDialogBase::Swallow, 0, this, "history_dlg",  false, "URL History", KDialogBase::Ok | KDialogBase::Cancel, KDialogBase::Ok, true);
			QStringList savedUrls = KrawlConfigSkel::savedUrls();
			m_hist_br = new HistoryBrowser(this, "history-widget", savedUrls);
			connect(m_history_dlg, SIGNAL(okClicked()), this, SLOT(slotAddUrlFromHistory()));
			connect(m_hist_br, SIGNAL(addUrlString(QString )), this, SLOT(slotAddUrlFromHistory(QString )));
			
			m_history_dlg->setMainWidget(m_hist_br);
			m_history_dlg->show();
			break;
		}
		case L_ADD:
		{
			QString q_str = KInputDialog::getText("Insert URL", "URL");
			m_cmbUrlsList->insertItem(q_str);
			createKrawlJob(q_str);
			m_cmbUrlsList->setCurrentItem(m_cmbUrlsList->count() - 1);
			m_LeechBar->getButton( L_START )->setEnabled( true );
			m_LeechBar->getButton( L_REMOVE )->setEnabled( true );
			m_LeechBar->getButton( L_CLEAR )->setEnabled( true );
			m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
			break;
		}
		default:
			break;
	}
}

void MultiJobHandler::dropWindowHandler(KURL::List _urlList)
{
	QValueListIterator<KURL> it;
	for (it = _urlList.begin(); it != _urlList.end(); it++)
	{
		KURL url = (*it);
		t_KrawlJob krawl_job = createKrawlJob(url.url());
		m_cmbUrlsList->insertURL(url);
	}
	m_LeechBar->getButton(L_REMOVE)->setEnabled(true);
	m_LeechBar->getButton(L_CLEAR)->setEnabled(true);	
	m_LeechBar->getButton(L_START)->setEnabled(true);
	m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
}

t_KrawlJob MultiJobHandler::createKrawlJob(QString _url_str)
{
	t_KrawlJob krawl_job;
	krawl_job.m_url_str = _url_str;
	JobOptions job_options;
	job_options = qso_frame->jobOptions(job_options);
	krawl_job.job_options = job_options;
	m_KrawlJobList.append(krawl_job);
	m_KrawlJobList[m_KrawlJobList.count() - 1] = krawl_job;
/*	int count = m_KrawlJobList.count();
	m_KrawlJobList.resize(m_KrawlJobList.count()	*/
	return krawl_job;
}

void MultiJobHandler::addKrawlJobs(QStringList _url_str_list)
{
	QStringList::Iterator it;
	for( it = _url_str_list.begin(); it != _url_str_list.end(); it++)
	{
		QString url_str = (*it);
		createKrawlJob(url_str);
	}
}		

void MultiJobHandler::dropWindowHandler(QString _urlStr)
{
	QStringList str_url_list = QStringList::split(QRegExp("[;,\\s]"), _urlStr, false);
	QStringList::Iterator it;
	KURL::List list;
	for (it = str_url_list.begin(); it != str_url_list.end(); it++)
	{
		KURL url(*it);
		list.append(url);
	}
	dropWindowHandler(list);
}

void MultiJobHandler::dropWindowClosed(const int x, const int y)
{
	m_btnDropTarget->toggle();
	drop_win_x = x;
	drop_win_y = y;
}

QString MultiJobHandler::updateComboIndex(int index)
{
	//qApp->lock();
	m_cmbUrlsList->setCurrentItem(index);
	QString url_str = m_cmbUrlsList->currentText();
	JobOptions job_opt = m_KrawlJobList[index].job_options;
	if (job_opt.crawl_mode == Krawler::Leech)
		m_LeechBar->getButton(L_SAVE)->setEnabled(true);
	m_info_panel_inst->changeKrawlDisp(m_qso_holder->modeDescStr(job_opt.crawl_mode));
	//qApp->unlock();
	return url_str;
}

void MultiJobHandler::cmbReturnPressed(const QString& _text)
{
	m_cmbUrlsList->changeItem(_text, m_cmbUrlsList->currentItem());
	uint curr_index = m_cmbUrlsList->currentItem();
	if ( curr_index < m_KrawlJobList.size() )
	{
		t_KrawlJob krawl_job = m_KrawlJobList[curr_index];
		krawl_job.m_url_str = _text;
		m_KrawlJobList[curr_index] = krawl_job;
	}
	else 
		createKrawlJob(_text);
	m_LeechBar->getButton(L_REMOVE)->setEnabled(true);
	m_LeechBar->getButton(L_CLEAR)->setEnabled(true);	
	m_LeechBar->getButton(L_START)->setEnabled(true);
	m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
}

void MultiJobHandler::cmbTextChanged(const QString& text)
{
	if (text.isEmpty())
	{
		m_LeechBar->getButton(L_REMOVE)->setEnabled(false);
		m_LeechBar->getButton(L_CLEAR)->setEnabled(false);	
		m_LeechBar->getButton(L_START)->setEnabled(false);
		m_LeechBar->getButton(L_OPTIONS)->setEnabled(false);
	}
	else
	{
		m_LeechBar->getButton(L_REMOVE)->setEnabled(true);
		m_LeechBar->getButton(L_CLEAR)->setEnabled(true);	
		m_LeechBar->getButton(L_START)->setEnabled(true);
		m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
	}
}

void MultiJobHandler::urlSettingsOkClicked()
{
	JobOptions url_settings = m_qso_holder->internalOptionsObject();
	url_settings = m_qso_holder->jobOptions(url_settings);
	int index = m_cmbUrlsList->currentItem();
	t_KrawlJob krawl_job = m_KrawlJobList[index];
	krawl_job.job_options = url_settings;
	m_KrawlJobList[index] = krawl_job;
}

QStringList MultiJobHandler::getComboUrls()
{
	QStringList urlList;
	for (int i = 0; i<m_cmbUrlsList->count(); i++)
		urlList.append(m_cmbUrlsList->text(i));
	
	return urlList;
}

void MultiJobHandler::krawlRunning(bool _flag)
{
	//qApp->lock();
	m_LeechBar->getButton(L_NEXT_LINK)->setEnabled(_flag);
	m_LeechBar->getButton(L_PAUSE)->setEnabled(_flag);
	if (_flag)
	{
		if (m_op_mode ==MULTI_JOB && m_cmbUrlsList->count() > 1)
			m_LeechBar->getButton(L_NEXT_URL)->setEnabled(_flag);
	}
	else m_LeechBar->getButton(L_NEXT_URL)->setEnabled(_flag);
	krawl_paused = false;
	//qApp->unlock();
}

void MultiJobHandler::setInfoPanelInst(InfoPanel* _info_panel_inst)
{
	m_info_panel_inst = _info_panel_inst;
}

void MultiJobHandler::setOpMode(int _mode)
{
	m_op_mode = _mode;
}

void MultiJobHandler::setPageOptions(QuickSetOptions* _qso_frame)
{
	qso_frame = _qso_frame;
}

void MultiJobHandler::btnDropTargetClicked()
{
	if (!m_drop_target_flag || m_btnDropTarget->isOn())
	{
		m_drop_target_flag = true;
		if (!m_btnDropTarget->isOn())
			m_btnDropTarget->setOn(true);
		////////////////////////////////////////////////////////
		KMessageBox::information(this, i18n("You can drop multiple URLs on the drop target. Dropped URLs appear in the combobox to the right of the drop target button. URLs can be edited, removed and each URL can have its own crawl configuration."), i18n("Drop Window Information"), i18n("Do not show me this message again."));
		////////////////////////////////////////////////////////
		if (drop_win_x == -1 && drop_win_y == -1)
		{
			QPoint p = QWidget::mapToGlobal(QPoint(m_btnDropTarget->x(), m_btnDropTarget->y() + m_btnDropTarget->height()));
			drop_win_x = p.x();
			drop_win_y = p.y();
		}
		win = new DropWindow(m_container_id, drop_win_x, drop_win_y);
		connect(win, SIGNAL(droppedItem(KURL::List )), this, SLOT(dropWindowHandler(KURL::List )));
		connect(win, SIGNAL(droppedItem(QString )), this, SLOT(dropWindowHandler(QString )));
		connect(win, SIGNAL(windowClosed(const int, const int)), this, SLOT(dropWindowClosed(const int, const int)));
		win->show();
	}
	else 
	{
		if (win) 
			win->close();
		drop_win_x = win->x();
		drop_win_y = win->y();
		delete win;
		win = 0;
		m_drop_target_flag = false;
	}
}

void MultiJobHandler::enableSave(bool _flag)
{
	//qApp->lock();
	m_LeechBar->getButton(L_SAVE)->setEnabled(_flag);
	//qApp->unlock();
}

void MultiJobHandler::setStopBtnState(bool _enable)
{
	//qApp->lock();
	m_LeechBar->getButton(L_STOP)->setEnabled( _enable );
	//qApp->unlock();
}

bool MultiJobHandler::isStopBtnEnabled()
{
	return m_LeechBar->getButton(L_STOP)->isEnabled();
}

void MultiJobHandler::slotAddUrlFromHistory(QString _str)
{
	m_cmbUrlsList->insertItem(_str);
	createKrawlJob(_str);
	m_cmbUrlsList->setCurrentItem(m_cmbUrlsList->count() - 1);
	m_history_dlg->close();
	m_LeechBar->getButton( L_START )->setEnabled( true );
	m_LeechBar->getButton( L_REMOVE )->setEnabled( true );
	m_LeechBar->getButton( L_CLEAR )->setEnabled( true );
	m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
}

void MultiJobHandler::slotAddUrlFromHistory()
{
	int last_index = m_cmbUrlsList->count() - 1;
	m_cmbUrlsList->insertStringList(m_hist_br->getSelectedUrls());
	addKrawlJobs( m_hist_br->getSelectedUrls() );
	m_cmbUrlsList->setCurrentItem(last_index + 1);
	m_LeechBar->getButton( L_START )->setEnabled( true );
	m_LeechBar->getButton( L_REMOVE )->setEnabled( true );
	m_LeechBar->getButton( L_CLEAR )->setEnabled( true );
	m_LeechBar->getButton(L_OPTIONS)->setEnabled(true);
}

void MultiJobHandler::debugMsg(QString _str)
{
	kdDebug(9815578)<<"MultiJobHandler.... "<<_str<<endl;
}

