/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef NOTIFIYWINDOW_H
#define NOTIFIYWINDOW_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>

/**
@author Sayantam Dey
*/
class NotifyWindow : public QWidget
{
Q_OBJECT
public:
    NotifyWindow(QWidget *parent = 0, const char *name = 0, bool _enable_timer = false, const char* _disp_text = 0);

    ~NotifyWindow();

protected:
	virtual void mousePressEvent(QMouseEvent* e);
	virtual void mouseMoveEvent(QMouseEvent* e);
	void showEvent(QShowEvent* e);
	void repositionWidget();
	void drawWindow(QString _disp_text);
		
private:
	int oldX, oldY;
	bool m_enable_timer;
	int default_width;
	int default_height;
	QBitmap mask;
	QPixmap* pm;
	
protected slots:
	void timerSlot();
};

#endif
