/***************************************************************************
 *   Copyright (C) 2004 by Sayantam Dey                                    *
 *   sayantam@gmail.com                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef QUICKSETOPTIONS_H
#define QUICKSETOPTIONS_H

#include "pgoptions.h"
#include "krawler.h"

class QuickSetOptions : public PgOptions
{
  Q_OBJECT

public:
  QuickSetOptions(QWidget* parent = 0, const char* name = 0, WFlags fl = 0 );
  ~QuickSetOptions();
  /*$PUBLIC_FUNCTIONS$*/
	int crawlDepth();
	bool traverseOut();
	bool linkOutsidePath();
	void loadSettings();
	void loadSettingsFromOptions(const JobOptions& job_opt);
	int krawlMode();			
	bool fileTypeList(QStringList &_type_list);
	QStringList dcTypeList();
	JobOptions& jobOptions(JobOptions& job_ptr);
	JobOptions& internalOptionsObject();
	QString modeDescStr(int _krawl_mode);
		
public slots:
  /*$PUBLIC_SLOTS$*/

protected:
	JobOptions internal_options_object;
  /*$PROTECTED_FUNCTIONS$*/
	void setKrawlMode(int _krawl_mode);

protected slots:
  /*$PROTECTED_SLOTS$*/
	void krawlModeChanged(int _button_id = -1);

signals:
	void changedKrawlMode(const QString &);
};


#endif

